---
Name: network-simple-bridge-with-addressing
Description: Creates a Bridge interface, and assigns IP Subnet block on it.
Documentation: |
  This network configuration creates a bridge device on the hypervisor
  (typically `vmbr0`), which the DRP Endpoint Virtual Machines will be
  attached to.

  An IP Subnet must be defined via the `proxmox/vm-external-subnet`
  Param, and it will be allocated on the interface defined in the Param
  `proxmox/vm-external-bridge`.

  IF this method is used, you generally will have to either SSH forward to the
  Proxmox Hypervisor, install a VPN service of some sort on the Hypervisor, or
  arrange for your external Networking devices (routers/switches) to route this
  IP block to the addressable interface of the Proxmox Hypervisor.

  The template defined in the Param `network-simple-bridge-with-addressing-template`
  will be expanded in place in this script then rendered to the Hypervisor.  This
  allows for in the field custom configurations that may not have been encompassed
  in the default Template configuration of this content pack.

Meta:
  color: blue
  feature-flags: sane-exit-codes
  icon: shopping cart
  title: RackN Content
RequiredParams:
  - "last-boot-macaddr"
  - "network-simple-bridge-with-addressing-template"
  - "proxmox/vm-external-bridge"
  - "proxmox/vm-external-subnet"
OptionalParams: []
Prerequisites: []
Templates:
  - Name: "network-simple-bridge-with-addressing.sh.tmpl"
    Contents: |-
      #!/usr/bin/env bash
      # Create a bridge on the hypervisor, use external IP addressing for DRP

      {{ template "setup.tmpl" . }}

      ###
      #   NOTE - the following variables can be used in the Template, ensure
      #          they are correctly set in this script.
      #
      #          BRIDGE    = External interface bridge name of DRP Endpoint VMs
      #          ADDRESS   = IP address in CIDR format of the BRIDGE subnet
      ###

      #MAC=$(drpcli machines get $RS_UUID param last-boot-macaddr | jq -r '.' | sed -e 's/^01-//' -e 's/-/:/g')
      MAC=$(echo '{{.Param "last-boot-macaddr"}}' | sed -e 's/^01-//' -e 's/-/:/g')
      MSG="Interface with MAC ('$MAC')"
      BRIDGE='{{ .Param "proxmox/vm-external-bridge" }}'
      TMPL='{{ .Param "network-simple-bridge-with-addressing-template" }}'
      {{$tmpl := (printf "%s" (.Param "network-simple-bridge-with-addressing-template")) -}}
      CIDR='{{ .Param "proxmox/vm-external-subnet" }}'

      NET=$(echo $CIDR | cut -d "/" -f1)
      PREFIX=$(echo $CIDR | cut -d "/" -f2)
      BASE=$(echo $NET | cut -d"." -f1-3)
      LAST=$(echo $NET | cut -d"." -f4)
      (( OCT = LAST + 1 ))
      IPADDR="${BASE}.${OCT}"
      ADDRESS="${IPADDR}/${PREFIX}"

      echo ""
      echo "Commenting out interface '$INTERFACE' definitions in /etc/network/interfaces"
      echo "NOTE: this is bad - if interface has a more complex or Static IP config, this may fail"
      sed -i.bak "s/^\(.*${INTERFACE}.*$\)/#\1/g" /etc/network/interfaces
      echo ""

      mkdir -p /etc/network/interfaces.d
      echo "Setting up Simple bridge with the following characteristics:"
      echo "------------------------------------------------------------"
      echo "Bridge interface name:            $BRIDGE"
      echo "Network Subnet CIDR:              $CIDR"
      echo "Assigning IP Address to bridge:   $ADDRESS"
      echo "Using Template for interface cfg: $TMPL"

      cat <<EOBR > /etc/network/interfaces.d/$BRIDGE
      {{.CallTemplate $tmpl .}}
      EOBR

      brctl show $BRIDGE > /dev/null 2>&1 && echo "Bridge '$BRIDGE' exists already" || brctl addbr $BRIDGE
      #ifdown $BRIDGE || true
      #ifup $BRIDGE
      systemctl restart networking.service
